# module Digest::Instance

This module provides instance methods for a digest implementation object to calculate message digest values.

### Public Instance Methods

digest_obj << string → digest_obj

Updates the digest using a given string and returns self.

The update() method and the left-shift operator are overridden by each implementation subclass. (One should be an alias for the other)

Alias for: update
digest_obj == another_digest_obj → boolean
digest_obj == string → boolean
Source

    static VALUE
    rb_digest_instance_equal(VALUE self, VALUE other)
    {
        VALUE str1, str2;

        if (rb_obj_is_kind_of(other, rb_mDigest_Instance) == Qtrue) {
            str1 = rb_digest_instance_digest(0, 0, self);
            str2 = rb_digest_instance_digest(0, 0, other);
        } else {
            str1 = rb_digest_instance_to_s(self);
            str2 = rb_check_string_type(other);
            if (NIL_P(str2)) return Qfalse;
        }

        /* never blindly assume that subclass methods return strings */
        StringValue(str1);
        StringValue(str2);

        if (RSTRING_LEN(str1) == RSTRING_LEN(str2) &&
            rb_str_cmp(str1, str2) == 0) {
            return Qtrue;
        }
        return Qfalse;
    }

If a string is given, checks whether it is equal to the hex-encoded hash value of the digest object. If another digest instance is given, checks whether they have the same hash value. Otherwise returns false.

base64digest (str = nil)
Source

    # File ext/digest/lib/digest.rb, line 82
    def base64digest(str = nil)
      [str ? digest(str) : digest].pack('m0')
    end

If none is given, returns the resulting hash value of the digest in a base64 encoded form, keeping the digest’s state.

If a `string` is given, returns the hash value for the given `string` in a base64 encoded form, resetting the digest to the initial state before and after the process.

In either case, the return value is properly padded with ‘=’ and contains no line feeds.

base64digest! ()
Source

    # File ext/digest/lib/digest.rb, line 88
    def base64digest!
      [digest!].pack('m0')
    end

Returns the resulting hash value and resets the digest to the initial state.

block_length → integer
Source

    static VALUE
    rb_digest_instance_block_length(VALUE self)
    {
        rb_digest_instance_method_unimpl(self, "block_length");

        UNREACHABLE;
    }

Returns the block length of the digest.

This method is overridden by each implementation subclass.

bubblebabble → hash_string
Source

    static VALUE
    rb_digest_instance_bubblebabble(VALUE self)
    {
        return bubblebabble_str_new(rb_funcall(self, id_digest, 0));
    }

Returns the resulting hash value in a Bubblebabble encoded form.

digest → string
digest(string) → string
Source

    static VALUE
    rb_digest_instance_digest(int argc, VALUE *argv, VALUE self)
    {
        VALUE str, value;

        if (rb_scan_args(argc, argv, "01", &str) > 0) {
            rb_funcall(self, id_reset, 0);
            rb_funcall(self, id_update, 1, str);
            value = rb_funcall(self, id_finish, 0);
            rb_funcall(self, id_reset, 0);
        } else {
            value = rb_funcall(rb_obj_clone(self), id_finish, 0);
        }

        return value;
    }

If none is given, returns the resulting hash value of the digest, keeping the digest’s state.

If a string is given, returns the hash value for the given string, resetting the digest to the initial state before and after the process.

digest! → string
Source

    static VALUE
    rb_digest_instance_digest_bang(VALUE self)
    {
        VALUE value = rb_funcall(self, id_finish, 0);
        rb_funcall(self, id_reset, 0);

        return value;
    }

Returns the resulting hash value and resets the digest to the initial state.

digest_length → integer
Source

    static VALUE
    rb_digest_instance_digest_length(VALUE self)
    {
        /* subclasses really should redefine this method */
        VALUE digest = rb_digest_instance_digest(0, 0, self);

        /* never blindly assume that #digest() returns a string */
        StringValue(digest);
        return LONG2NUM(RSTRING_LEN(digest));
    }

Returns the length of the hash value of the digest.

This method should be overridden by each implementation subclass. If not, digest_obj.digest().length() is returned.

file (name)
Source

    # File ext/digest/lib/digest.rb, line 63
    def file(name)
      File.open(name, "rb") {|f|
        buf = ""
        while f.read(16384, buf)
          update buf
        end
      }
      self
    end

Updates the digest with the contents of a given file name and returns self.

hexdigest → string
hexdigest(string) → string
Source

    static VALUE
    rb_digest_instance_hexdigest(int argc, VALUE *argv, VALUE self)
    {
        VALUE str, value;

        if (rb_scan_args(argc, argv, "01", &str) > 0) {
            rb_funcall(self, id_reset, 0);
            rb_funcall(self, id_update, 1, str);
            value = rb_funcall(self, id_finish, 0);
            rb_funcall(self, id_reset, 0);
        } else {
            value = rb_funcall(rb_obj_clone(self), id_finish, 0);
        }

        return hexencode_str_new(value);
    }

If none is given, returns the resulting hash value of the digest in a hex-encoded form, keeping the digest’s state.

If a string is given, returns the hash value for the given string in a hex-encoded form, resetting the digest to the initial state before and after the process.

hexdigest! → string
Source

    static VALUE
    rb_digest_instance_hexdigest_bang(VALUE self)
    {
        VALUE value = rb_funcall(self, id_finish, 0);
        rb_funcall(self, id_reset, 0);

        return hexencode_str_new(value);
    }

Returns the resulting hash value in a hex-encoded form and resets the digest to the initial state.

inspect → string
Source

    static VALUE
    rb_digest_instance_inspect(VALUE self)
    {
        VALUE str;
        size_t digest_len = 32;     /* about this size at least */
        const char *cname;

        cname = rb_obj_classname(self);

        /* #<Digest::ClassName: xxxxx...xxxx> */
        str = rb_str_buf_new(2 + strlen(cname) + 2 + digest_len * 2 + 1);
        rb_str_buf_cat2(str, "#<");
        rb_str_buf_cat2(str, cname);
        rb_str_buf_cat2(str, ": ");
        rb_str_buf_append(str, rb_digest_instance_hexdigest(0, 0, self));
        rb_str_buf_cat2(str, ">");
        return str;
    }

Creates a printable version of the digest object.

length → integer
Source

    static VALUE
    rb_digest_instance_length(VALUE self)
    {
        return rb_funcall(self, id_digest_length, 0);
    }

Returns digest_obj.digest_length().

Also aliased as: size
new → another_digest_obj
Source

    static VALUE
    rb_digest_instance_new(VALUE self)
    {
        VALUE clone = rb_obj_clone(self);
        rb_funcall(clone, id_reset, 0);
        return clone;
    }

Returns a new, initialized copy of the digest object. Equivalent to digest_obj.clone().reset().

reset → digest_obj
Source

    static VALUE
    rb_digest_instance_reset(VALUE self)
    {
        rb_digest_instance_method_unimpl(self, "reset");

        UNREACHABLE;
    }

Resets the digest to the initial state and returns self.

This method is overridden by each implementation subclass.

size → integer

Returns digest_obj.digest_length().

Alias for: length
to_s → string
Source

    static VALUE
    rb_digest_instance_to_s(VALUE self)
    {
        return rb_funcall(self, id_hexdigest, 0);
    }

Returns digest_obj.hexdigest().

update(string) → digest_obj
Source

    static VALUE
    rb_digest_instance_update(VALUE self, VALUE str)
    {
        rb_digest_instance_method_unimpl(self, "update");

        UNREACHABLE;
    }

Updates the digest using a given string and returns self.

The update() method and the left-shift operator are overridden by each implementation subclass. (One should be an alias for the other)

Also aliased as: <<

### Private Instance Methods

instance_eval { finish } → digest_obj
Source

    static VALUE
    rb_digest_instance_finish(VALUE self)
    {
        rb_digest_instance_method_unimpl(self, "finish");

        UNREACHABLE;
    }

Finishes the digest and returns the resulting hash value.

This method is overridden by each implementation subclass and often made private, because some of those subclasses may leave internal data uninitialized. Do not call this method from outside. Use `digest!()` instead, which ensures that internal data be reset for security reasons.